/*
 *  Stefan's Portable MakeTurn: "General-Purpose" Memory Buffer
 *
 *  (c) 1999 Stefan Reuther <Streu@gmx.de>
 */
#ifndef BUFFER_H
#define BUFFER_H

#include <cstddef>

class CBuffer {
    char* buffer;
    size_t length;
    size_t capacity;
 public:
    CBuffer();
    ~CBuffer();
    char* Ptr() { return buffer; }
    const char* Ptr() const { return buffer; }
    size_t Length() { return length; }
    void EnsureCapacity(size_t);
    void Append(const char* val, size_t len);
    void AppendWord(int);
    void AppendLong(long);
    void Clear() { length = 0; }
    int GetWord(size_t index);
    long GetLong(size_t index);
    unsigned long Sum();
    char& operator[](size_t x) { return buffer[x]; }
    char operator[](size_t x) const { return buffer[x]; }
};

#endif
