/*
 *  Stefan's Portable MakeTurn: Turn File Class
 *
 *  (c) 1999 Stefan Reuther <Streu@gmx.de>
 */
#ifndef TURNFILE_H
#define TURNFILE_H

#include <vector>
#include <string>
#include "buffer.h"

/* represents a Turn File */
class CTurnFile {
    std::vector<long> ptrs;     // pointers to commands
    CBuffer data;               // trn file commands
    std::string timestamp;      // 18 characters timestamp
    CBuffer header;             // header
    int player;                 // player id
    int turn_nr;
 public:
    CTurnFile(int aplayer, const char* atimestamp, int turn_nr);
    void AddCommand(int acode);
    void AddData(const char* adata, int alength);
    unsigned long GenerateHeader();
    CBuffer& Data() { return data; }
    void Write(std::string filename, long* templock);
    void MakeWinplanTrailer();
};

unsigned long StringSum(const std::string& s);

#endif
